Index: uspace/lib/ui/test/clickmatic.c
===================================================================
--- uspace/lib/ui/test/clickmatic.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/test/clickmatic.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,135 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <ui/clickmatic.h>
+#include <ui/ui.h>
+#include "../private/clickmatic.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(clickmatic);
+
+static void test_clicked(ui_clickmatic_t *, void *);
+
+static ui_clickmatic_cb_t test_cb = {
+	.clicked = test_clicked
+};
+
+typedef struct {
+	int clicked_cnt;
+} test_resp_t;
+
+/** Create and destroy clickmatic */
+PCUT_TEST(create_destroy)
+{
+	ui_t *ui = NULL;
+	ui_clickmatic_t *clickmatic = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_clickmatic_create(ui, &clickmatic);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(clickmatic);
+
+	ui_clickmatic_destroy(clickmatic);
+	ui_destroy(ui);
+}
+
+/** ui_clickmatic_destroy() can take NULL argument (no-op) */
+PCUT_TEST(destroy_null)
+{
+	ui_clickmatic_destroy(NULL);
+}
+
+/** ui_clickmatic_set_cb() sets internal fields */
+PCUT_TEST(set_cb)
+{
+	ui_t *ui = NULL;
+	ui_clickmatic_t *clickmatic = NULL;
+	test_resp_t test_resp;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_clickmatic_create(ui, &clickmatic);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(clickmatic);
+
+	ui_clickmatic_set_cb(clickmatic, &test_cb, (void *)&test_resp);
+	PCUT_ASSERT_EQUALS(&test_cb, clickmatic->cb);
+	PCUT_ASSERT_EQUALS((void *)&test_resp, clickmatic->arg);
+
+	ui_clickmatic_destroy(clickmatic);
+	ui_destroy(ui);
+}
+
+/** Pressing and releasing clickmatic generates one event */
+PCUT_TEST(press_release)
+{
+	ui_t *ui = NULL;
+	ui_clickmatic_t *clickmatic = NULL;
+	test_resp_t test_resp;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_clickmatic_create(ui, &clickmatic);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(clickmatic);
+
+	test_resp.clicked_cnt = 0;
+
+	ui_clickmatic_set_cb(clickmatic, &test_cb, (void *)&test_resp);
+	PCUT_ASSERT_EQUALS(&test_cb, clickmatic->cb);
+	PCUT_ASSERT_EQUALS((void *)&test_resp, clickmatic->arg);
+
+	PCUT_ASSERT_INT_EQUALS(0, test_resp.clicked_cnt);
+
+	ui_clickmatic_press(clickmatic);
+	ui_clickmatic_release(clickmatic);
+
+	PCUT_ASSERT_INT_EQUALS(1, test_resp.clicked_cnt);
+
+	ui_clickmatic_destroy(clickmatic);
+	ui_destroy(ui);
+}
+
+static void test_clicked(ui_clickmatic_t *clickmatic, void *arg)
+{
+	test_resp_t *test_resp = (test_resp_t *)arg;
+
+	++test_resp->clicked_cnt;
+}
+
+PCUT_EXPORT(clickmatic);
Index: uspace/lib/ui/test/control.c
===================================================================
--- uspace/lib/ui/test/control.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/control.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -33,51 +33,12 @@
 #include <pcut/pcut.h>
 #include <ui/control.h>
+#include <ui/testctl.h>
 #include <stdbool.h>
 #include <types/ui/event.h>
+#include "../private/testctl.h"
 
 PCUT_INIT;
 
 PCUT_TEST_SUITE(control);
-
-static void test_ctl_destroy(void *);
-static errno_t test_ctl_paint(void *);
-static ui_evclaim_t test_ctl_kbd_event(void *, kbd_event_t *);
-static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
-static void test_ctl_unfocus(void *);
-
-static ui_control_ops_t test_ctl_ops = {
-	.destroy = test_ctl_destroy,
-	.paint = test_ctl_paint,
-	.kbd_event = test_ctl_kbd_event,
-	.pos_event = test_ctl_pos_event,
-	.unfocus = test_ctl_unfocus
-};
-
-/** Test response */
-typedef struct {
-	/** Claim to return */
-	ui_evclaim_t claim;
-	/** Result code to return */
-	errno_t rc;
-
-	/** @c true iff destroy was called */
-	bool destroy;
-
-	/** @c true iff paint was called */
-	bool paint;
-
-	/** @c true iff kbd_event was called */
-	bool kbd;
-	/** Keyboard event that was sent */
-	kbd_event_t kevent;
-
-	/** @c true iff pos_event was called */
-	bool pos;
-	/** Position event that was sent */
-	pos_event_t pevent;
-
-	/** @c true iff unfocus was called */
-	bool unfocus;
-} test_resp_t;
 
 /** Allocate and deallocate control */
@@ -87,5 +48,5 @@
 	errno_t rc;
 
-	rc = ui_control_new(&test_ctl_ops, NULL, &control);
+	rc = ui_control_new(&ui_test_ctl_ops, NULL, &control);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(control);
@@ -103,16 +64,16 @@
 PCUT_TEST(destroy)
 {
-	ui_control_t *control = NULL;
-	test_resp_t resp;
+	ui_test_ctl_t *testctl = NULL;
+	ui_tc_resp_t resp;
 	errno_t rc;
 
-	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	rc = ui_test_ctl_create(&resp, &testctl);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(control);
+	PCUT_ASSERT_NOT_NULL(testctl);
 
 	resp.rc = EOK;
 	resp.destroy = false;
 
-	ui_control_destroy(control);
+	ui_control_destroy(ui_test_ctl_ctl(testctl));
 	PCUT_ASSERT_TRUE(resp.destroy);
 }
@@ -121,16 +82,16 @@
 PCUT_TEST(paint)
 {
-	ui_control_t *control = NULL;
-	test_resp_t resp;
+	ui_test_ctl_t *testctl = NULL;
+	ui_tc_resp_t resp;
 	errno_t rc;
 
-	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	rc = ui_test_ctl_create(&resp, &testctl);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(control);
+	PCUT_ASSERT_NOT_NULL(testctl);
 
 	resp.rc = EOK;
 	resp.paint = false;
 
-	rc = ui_control_paint(control);
+	rc = ui_control_paint(ui_test_ctl_ctl(testctl));
 	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
 	PCUT_ASSERT_TRUE(resp.paint);
@@ -139,9 +100,9 @@
 	resp.paint = false;
 
-	rc = ui_control_paint(control);
+	rc = ui_control_paint(ui_test_ctl_ctl(testctl));
 	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
 	PCUT_ASSERT_TRUE(resp.paint);
 
-	ui_control_delete(control);
+	ui_test_ctl_destroy(testctl);
 }
 
@@ -149,13 +110,13 @@
 PCUT_TEST(kbd_event)
 {
-	ui_control_t *control = NULL;
-	test_resp_t resp;
+	ui_test_ctl_t *testctl = NULL;
+	ui_tc_resp_t resp;
 	kbd_event_t event;
 	ui_evclaim_t claim;
 	errno_t rc;
 
-	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	rc = ui_test_ctl_create(&resp, &testctl);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(control);
+	PCUT_ASSERT_NOT_NULL(testctl);
 
 	resp.claim = ui_claimed;
@@ -166,5 +127,5 @@
 	event.c = '@';
 
-	claim = ui_control_kbd_event(control, &event);
+	claim = ui_control_kbd_event(ui_test_ctl_ctl(testctl), &event);
 	PCUT_ASSERT_EQUALS(resp.claim, claim);
 	PCUT_ASSERT_TRUE(resp.kbd);
@@ -174,5 +135,5 @@
 	PCUT_ASSERT_INT_EQUALS(resp.kevent.c, event.c);
 
-	ui_control_delete(control);
+	ui_test_ctl_destroy(testctl);
 }
 
@@ -180,13 +141,13 @@
 PCUT_TEST(pos_event)
 {
-	ui_control_t *control = NULL;
-	test_resp_t resp;
+	ui_test_ctl_t *testctl = NULL;
+	ui_tc_resp_t resp;
 	pos_event_t event;
 	ui_evclaim_t claim;
 	errno_t rc;
 
-	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	rc = ui_test_ctl_create(&resp, &testctl);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(control);
+	PCUT_ASSERT_NOT_NULL(testctl);
 
 	resp.claim = ui_claimed;
@@ -198,5 +159,5 @@
 	event.vpos = 4;
 
-	claim = ui_control_pos_event(control, &event);
+	claim = ui_control_pos_event(ui_test_ctl_ctl(testctl), &event);
 	PCUT_ASSERT_EQUALS(resp.claim, claim);
 	PCUT_ASSERT_TRUE(resp.pos);
@@ -207,5 +168,5 @@
 	PCUT_ASSERT_INT_EQUALS(resp.pevent.vpos, event.vpos);
 
-	ui_control_delete(control);
+	ui_test_ctl_destroy(testctl);
 }
 
@@ -213,60 +174,19 @@
 PCUT_TEST(unfocus)
 {
-	ui_control_t *control = NULL;
-	test_resp_t resp;
+	ui_test_ctl_t *testctl = NULL;
+	ui_tc_resp_t resp;
 	errno_t rc;
 
-	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	rc = ui_test_ctl_create(&resp, &testctl);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(control);
+	PCUT_ASSERT_NOT_NULL(testctl);
 
 	resp.unfocus = false;
 
-	ui_control_unfocus(control);
+	ui_control_unfocus(ui_test_ctl_ctl(testctl), 42);
 	PCUT_ASSERT_TRUE(resp.unfocus);
+	PCUT_ASSERT_INT_EQUALS(42, resp.unfocus_nfocus);
 
-	ui_control_delete(control);
-}
-
-static void test_ctl_destroy(void *arg)
-{
-	test_resp_t *resp = (test_resp_t *) arg;
-
-	resp->destroy = true;
-}
-
-static errno_t test_ctl_paint(void *arg)
-{
-	test_resp_t *resp = (test_resp_t *) arg;
-
-	resp->paint = true;
-	return resp->rc;
-}
-
-static ui_evclaim_t test_ctl_kbd_event(void *arg, kbd_event_t *event)
-{
-	test_resp_t *resp = (test_resp_t *) arg;
-
-	resp->kbd = true;
-	resp->kevent = *event;
-
-	return resp->claim;
-}
-
-static ui_evclaim_t test_ctl_pos_event(void *arg, pos_event_t *event)
-{
-	test_resp_t *resp = (test_resp_t *) arg;
-
-	resp->pos = true;
-	resp->pevent = *event;
-
-	return resp->claim;
-}
-
-static void test_ctl_unfocus(void *arg)
-{
-	test_resp_t *resp = (test_resp_t *) arg;
-
-	resp->unfocus = true;
+	ui_test_ctl_destroy(testctl);
 }
 
Index: uspace/lib/ui/test/entry.c
===================================================================
--- uspace/lib/ui/test/entry.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/entry.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -106,8 +106,21 @@
 PCUT_TEST(set_halign)
 {
-	ui_entry_t *entry;
-	errno_t rc;
-
-	rc = ui_entry_create(NULL, "Hello", &entry);
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t params;
+	ui_entry_t *entry;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	rc = ui_entry_create(window, "Hello", &entry);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -118,4 +131,6 @@
 
 	ui_entry_destroy(entry);
+	ui_window_destroy(window);
+	ui_destroy(ui);
 }
 
